unit uGame;


interface

uses System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants, FMX.Objects, FMX.Layouts, FMX.Graphics;

type
  TDirection = (droite, gauche);
  TGBECollisionResult = record
    bool : boolean;
    objet : TRectangle;
  end;

  TScrolling = class(TLayout)
  private
    fRectangle : TRectangle;
    fZOrder : integer;
    fVitesse, fScaleX, fScaleY : single;
  public
    constructor create(AOwner: TComponent); override;
    destructor Destroy; override;

    property Rectangle : TRectangle read fRectangle write fRectangle;
    property ZOrder : integer read fZOrder write fZOrder;
    property ScaleX : single read fScaleX write fScaleX;
    property ScaleY : single read fScaleY write fScaleY;
    property Vitesse : single read fVitesse write fVitesse;
  end;

  TTileStyle = (vide, bloc, blocHaut, blocGauche, blocDroit, blocBas, eau, sable, ressort, trou, bonusVie, bonus);
  TPlateforme = record
  public
    style : TTileStyle;
    image, animation :string;
  end;

  TEnnemi = record
  public
    image1, image2, deplacement: string;
    count : integer;
    duration : single;
  end;

  TBonus = record
  public
    image: string;
    count : integer;
    duration : single;
  end;


const
  vitesseXMax = 2.5;
  vitesseSaut = 8;
  scale = 2;

implementation

constructor TScrolling.Create(AOwner: TComponent);
begin
  inherited;
  fRectangle := TRectangle.Create(nil);
  fRectangle.Parent := self;
  fRectangle.HitTest := false;
  fRectangle.Fill.Kind := TBrushKind.Bitmap;
  fRectangle.Fill.Bitmap.WrapMode := TWrapMode.Tile;
  fRectangle.stroke.Dash := TStrokeDash.Solid;
  fRectangle.stroke.Color := TAlphaColorRec.Null;
  fRectangle.stroke.Kind := TBrushKind.Solid;
  fRectangle.Stroke.Thickness := 1;
  fZOrder := 0;
  fVitesse := 0;
end;

destructor TScrolling.Destroy;
begin
  inherited;
end;

end.
